package com.hai.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HighOrderExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighOrderExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTitleIsNull() {
            addCriterion("title is null");
            return (Criteria) this;
        }

        public Criteria andTitleIsNotNull() {
            addCriterion("title is not null");
            return (Criteria) this;
        }

        public Criteria andTitleEqualTo(String value) {
            addCriterion("title =", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotEqualTo(String value) {
            addCriterion("title <>", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleGreaterThan(String value) {
            addCriterion("title >", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleGreaterThanOrEqualTo(String value) {
            addCriterion("title >=", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLessThan(String value) {
            addCriterion("title <", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLessThanOrEqualTo(String value) {
            addCriterion("title <=", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLike(String value) {
            addCriterion("title like", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotLike(String value) {
            addCriterion("title not like", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleIn(List<String> values) {
            addCriterion("title in", values, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotIn(List<String> values) {
            addCriterion("title not in", values, "title");
            return (Criteria) this;
        }

        public Criteria andTitleBetween(String value1, String value2) {
            addCriterion("title between", value1, value2, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotBetween(String value1, String value2) {
            addCriterion("title not between", value1, value2, "title");
            return (Criteria) this;
        }

        public Criteria andSearchTitleIsNull() {
            addCriterion("search_title is null");
            return (Criteria) this;
        }

        public Criteria andSearchTitleIsNotNull() {
            addCriterion("search_title is not null");
            return (Criteria) this;
        }

        public Criteria andSearchTitleEqualTo(String value) {
            addCriterion("search_title =", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleNotEqualTo(String value) {
            addCriterion("search_title <>", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleGreaterThan(String value) {
            addCriterion("search_title >", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleGreaterThanOrEqualTo(String value) {
            addCriterion("search_title >=", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleLessThan(String value) {
            addCriterion("search_title <", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleLessThanOrEqualTo(String value) {
            addCriterion("search_title <=", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleLike(String value) {
            addCriterion("search_title like", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleNotLike(String value) {
            addCriterion("search_title not like", value, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleIn(List<String> values) {
            addCriterion("search_title in", values, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleNotIn(List<String> values) {
            addCriterion("search_title not in", values, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleBetween(String value1, String value2) {
            addCriterion("search_title between", value1, value2, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andSearchTitleNotBetween(String value1, String value2) {
            addCriterion("search_title not between", value1, value2, "searchTitle");
            return (Criteria) this;
        }

        public Criteria andProductTypeIsNull() {
            addCriterion("product_type is null");
            return (Criteria) this;
        }

        public Criteria andProductTypeIsNotNull() {
            addCriterion("product_type is not null");
            return (Criteria) this;
        }

        public Criteria andProductTypeEqualTo(Integer value) {
            addCriterion("product_type =", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeNotEqualTo(Integer value) {
            addCriterion("product_type <>", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeGreaterThan(Integer value) {
            addCriterion("product_type >", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("product_type >=", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeLessThan(Integer value) {
            addCriterion("product_type <", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeLessThanOrEqualTo(Integer value) {
            addCriterion("product_type <=", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeIn(List<Integer> values) {
            addCriterion("product_type in", values, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeNotIn(List<Integer> values) {
            addCriterion("product_type not in", values, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeBetween(Integer value1, Integer value2) {
            addCriterion("product_type between", value1, value2, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("product_type not between", value1, value2, "productType");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Long value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Long value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Long value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Long value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Long value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Long> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Long> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Long value1, Long value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Long value1, Long value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdIsNull() {
            addCriterion("mem_discount_id is null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdIsNotNull() {
            addCriterion("mem_discount_id is not null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdEqualTo(Long value) {
            addCriterion("mem_discount_id =", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdNotEqualTo(Long value) {
            addCriterion("mem_discount_id <>", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdGreaterThan(Long value) {
            addCriterion("mem_discount_id >", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mem_discount_id >=", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdLessThan(Long value) {
            addCriterion("mem_discount_id <", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdLessThanOrEqualTo(Long value) {
            addCriterion("mem_discount_id <=", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdIn(List<Long> values) {
            addCriterion("mem_discount_id in", values, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdNotIn(List<Long> values) {
            addCriterion("mem_discount_id not in", values, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdBetween(Long value1, Long value2) {
            addCriterion("mem_discount_id between", value1, value2, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdNotBetween(Long value1, Long value2) {
            addCriterion("mem_discount_id not between", value1, value2, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameIsNull() {
            addCriterion("mem_discount_name is null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameIsNotNull() {
            addCriterion("mem_discount_name is not null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameEqualTo(String value) {
            addCriterion("mem_discount_name =", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotEqualTo(String value) {
            addCriterion("mem_discount_name <>", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameGreaterThan(String value) {
            addCriterion("mem_discount_name >", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameGreaterThanOrEqualTo(String value) {
            addCriterion("mem_discount_name >=", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameLessThan(String value) {
            addCriterion("mem_discount_name <", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameLessThanOrEqualTo(String value) {
            addCriterion("mem_discount_name <=", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameLike(String value) {
            addCriterion("mem_discount_name like", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotLike(String value) {
            addCriterion("mem_discount_name not like", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameIn(List<String> values) {
            addCriterion("mem_discount_name in", values, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotIn(List<String> values) {
            addCriterion("mem_discount_name not in", values, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameBetween(String value1, String value2) {
            addCriterion("mem_discount_name between", value1, value2, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotBetween(String value1, String value2) {
            addCriterion("mem_discount_name not between", value1, value2, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemIdIsNull() {
            addCriterion("mem_id is null");
            return (Criteria) this;
        }

        public Criteria andMemIdIsNotNull() {
            addCriterion("mem_id is not null");
            return (Criteria) this;
        }

        public Criteria andMemIdEqualTo(Long value) {
            addCriterion("mem_id =", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdNotEqualTo(Long value) {
            addCriterion("mem_id <>", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdGreaterThan(Long value) {
            addCriterion("mem_id >", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mem_id >=", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdLessThan(Long value) {
            addCriterion("mem_id <", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdLessThanOrEqualTo(Long value) {
            addCriterion("mem_id <=", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdIn(List<Long> values) {
            addCriterion("mem_id in", values, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdNotIn(List<Long> values) {
            addCriterion("mem_id not in", values, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdBetween(Long value1, Long value2) {
            addCriterion("mem_id between", value1, value2, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdNotBetween(Long value1, Long value2) {
            addCriterion("mem_id not between", value1, value2, "memId");
            return (Criteria) this;
        }

        public Criteria andMemNameIsNull() {
            addCriterion("mem_name is null");
            return (Criteria) this;
        }

        public Criteria andMemNameIsNotNull() {
            addCriterion("mem_name is not null");
            return (Criteria) this;
        }

        public Criteria andMemNameEqualTo(String value) {
            addCriterion("mem_name =", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameNotEqualTo(String value) {
            addCriterion("mem_name <>", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameGreaterThan(String value) {
            addCriterion("mem_name >", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameGreaterThanOrEqualTo(String value) {
            addCriterion("mem_name >=", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameLessThan(String value) {
            addCriterion("mem_name <", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameLessThanOrEqualTo(String value) {
            addCriterion("mem_name <=", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameLike(String value) {
            addCriterion("mem_name like", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameNotLike(String value) {
            addCriterion("mem_name not like", value, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameIn(List<String> values) {
            addCriterion("mem_name in", values, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameNotIn(List<String> values) {
            addCriterion("mem_name not in", values, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameBetween(String value1, String value2) {
            addCriterion("mem_name between", value1, value2, "memName");
            return (Criteria) this;
        }

        public Criteria andMemNameNotBetween(String value1, String value2) {
            addCriterion("mem_name not between", value1, value2, "memName");
            return (Criteria) this;
        }

        public Criteria andMemPhoneIsNull() {
            addCriterion("mem_phone is null");
            return (Criteria) this;
        }

        public Criteria andMemPhoneIsNotNull() {
            addCriterion("mem_phone is not null");
            return (Criteria) this;
        }

        public Criteria andMemPhoneEqualTo(String value) {
            addCriterion("mem_phone =", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneNotEqualTo(String value) {
            addCriterion("mem_phone <>", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneGreaterThan(String value) {
            addCriterion("mem_phone >", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("mem_phone >=", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneLessThan(String value) {
            addCriterion("mem_phone <", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneLessThanOrEqualTo(String value) {
            addCriterion("mem_phone <=", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneLike(String value) {
            addCriterion("mem_phone like", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneNotLike(String value) {
            addCriterion("mem_phone not like", value, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneIn(List<String> values) {
            addCriterion("mem_phone in", values, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneNotIn(List<String> values) {
            addCriterion("mem_phone not in", values, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneBetween(String value1, String value2) {
            addCriterion("mem_phone between", value1, value2, "memPhone");
            return (Criteria) this;
        }

        public Criteria andMemPhoneNotBetween(String value1, String value2) {
            addCriterion("mem_phone not between", value1, value2, "memPhone");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoIsNull() {
            addCriterion("combine_order_no is null");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoIsNotNull() {
            addCriterion("combine_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoEqualTo(String value) {
            addCriterion("combine_order_no =", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoNotEqualTo(String value) {
            addCriterion("combine_order_no <>", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoGreaterThan(String value) {
            addCriterion("combine_order_no >", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("combine_order_no >=", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoLessThan(String value) {
            addCriterion("combine_order_no <", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoLessThanOrEqualTo(String value) {
            addCriterion("combine_order_no <=", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoLike(String value) {
            addCriterion("combine_order_no like", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoNotLike(String value) {
            addCriterion("combine_order_no not like", value, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoIn(List<String> values) {
            addCriterion("combine_order_no in", values, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoNotIn(List<String> values) {
            addCriterion("combine_order_no not in", values, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoBetween(String value1, String value2) {
            addCriterion("combine_order_no between", value1, value2, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andCombineOrderNoNotBetween(String value1, String value2) {
            addCriterion("combine_order_no not between", value1, value2, "combineOrderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIsNull() {
            addCriterion("pay_serial_no is null");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIsNotNull() {
            addCriterion("pay_serial_no is not null");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoEqualTo(String value) {
            addCriterion("pay_serial_no =", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotEqualTo(String value) {
            addCriterion("pay_serial_no <>", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoGreaterThan(String value) {
            addCriterion("pay_serial_no >", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoGreaterThanOrEqualTo(String value) {
            addCriterion("pay_serial_no >=", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLessThan(String value) {
            addCriterion("pay_serial_no <", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLessThanOrEqualTo(String value) {
            addCriterion("pay_serial_no <=", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLike(String value) {
            addCriterion("pay_serial_no like", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotLike(String value) {
            addCriterion("pay_serial_no not like", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIn(List<String> values) {
            addCriterion("pay_serial_no in", values, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotIn(List<String> values) {
            addCriterion("pay_serial_no not in", values, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoBetween(String value1, String value2) {
            addCriterion("pay_serial_no between", value1, value2, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotBetween(String value1, String value2) {
            addCriterion("pay_serial_no not between", value1, value2, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelIsNull() {
            addCriterion("pay_channel is null");
            return (Criteria) this;
        }

        public Criteria andPayChannelIsNotNull() {
            addCriterion("pay_channel is not null");
            return (Criteria) this;
        }

        public Criteria andPayChannelEqualTo(Integer value) {
            addCriterion("pay_channel =", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelNotEqualTo(Integer value) {
            addCriterion("pay_channel <>", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelGreaterThan(Integer value) {
            addCriterion("pay_channel >", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelGreaterThanOrEqualTo(Integer value) {
            addCriterion("pay_channel >=", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelLessThan(Integer value) {
            addCriterion("pay_channel <", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelLessThanOrEqualTo(Integer value) {
            addCriterion("pay_channel <=", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelIn(List<Integer> values) {
            addCriterion("pay_channel in", values, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelNotIn(List<Integer> values) {
            addCriterion("pay_channel not in", values, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelBetween(Integer value1, Integer value2) {
            addCriterion("pay_channel between", value1, value2, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelNotBetween(Integer value1, Integer value2) {
            addCriterion("pay_channel not between", value1, value2, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoIsNull() {
            addCriterion("pay_channel_order_no is null");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoIsNotNull() {
            addCriterion("pay_channel_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoEqualTo(String value) {
            addCriterion("pay_channel_order_no =", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoNotEqualTo(String value) {
            addCriterion("pay_channel_order_no <>", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoGreaterThan(String value) {
            addCriterion("pay_channel_order_no >", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("pay_channel_order_no >=", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoLessThan(String value) {
            addCriterion("pay_channel_order_no <", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoLessThanOrEqualTo(String value) {
            addCriterion("pay_channel_order_no <=", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoLike(String value) {
            addCriterion("pay_channel_order_no like", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoNotLike(String value) {
            addCriterion("pay_channel_order_no not like", value, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoIn(List<String> values) {
            addCriterion("pay_channel_order_no in", values, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoNotIn(List<String> values) {
            addCriterion("pay_channel_order_no not in", values, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoBetween(String value1, String value2) {
            addCriterion("pay_channel_order_no between", value1, value2, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayChannelOrderNoNotBetween(String value1, String value2) {
            addCriterion("pay_channel_order_no not between", value1, value2, "payChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNull() {
            addCriterion("pay_type is null");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNotNull() {
            addCriterion("pay_type is not null");
            return (Criteria) this;
        }

        public Criteria andPayTypeEqualTo(Integer value) {
            addCriterion("pay_type =", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotEqualTo(Integer value) {
            addCriterion("pay_type <>", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThan(Integer value) {
            addCriterion("pay_type >", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("pay_type >=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThan(Integer value) {
            addCriterion("pay_type <", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThanOrEqualTo(Integer value) {
            addCriterion("pay_type <=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeIn(List<Integer> values) {
            addCriterion("pay_type in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotIn(List<Integer> values) {
            addCriterion("pay_type not in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeBetween(Integer value1, Integer value2) {
            addCriterion("pay_type between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("pay_type not between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andMemCardIdIsNull() {
            addCriterion("mem_card_id is null");
            return (Criteria) this;
        }

        public Criteria andMemCardIdIsNotNull() {
            addCriterion("mem_card_id is not null");
            return (Criteria) this;
        }

        public Criteria andMemCardIdEqualTo(Long value) {
            addCriterion("mem_card_id =", value, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdNotEqualTo(Long value) {
            addCriterion("mem_card_id <>", value, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdGreaterThan(Long value) {
            addCriterion("mem_card_id >", value, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mem_card_id >=", value, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdLessThan(Long value) {
            addCriterion("mem_card_id <", value, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdLessThanOrEqualTo(Long value) {
            addCriterion("mem_card_id <=", value, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdIn(List<Long> values) {
            addCriterion("mem_card_id in", values, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdNotIn(List<Long> values) {
            addCriterion("mem_card_id not in", values, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdBetween(Long value1, Long value2) {
            addCriterion("mem_card_id between", value1, value2, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardIdNotBetween(Long value1, Long value2) {
            addCriterion("mem_card_id not between", value1, value2, "memCardId");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeIsNull() {
            addCriterion("mem_card_type is null");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeIsNotNull() {
            addCriterion("mem_card_type is not null");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeEqualTo(Integer value) {
            addCriterion("mem_card_type =", value, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeNotEqualTo(Integer value) {
            addCriterion("mem_card_type <>", value, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeGreaterThan(Integer value) {
            addCriterion("mem_card_type >", value, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("mem_card_type >=", value, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeLessThan(Integer value) {
            addCriterion("mem_card_type <", value, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeLessThanOrEqualTo(Integer value) {
            addCriterion("mem_card_type <=", value, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeIn(List<Integer> values) {
            addCriterion("mem_card_type in", values, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeNotIn(List<Integer> values) {
            addCriterion("mem_card_type not in", values, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeBetween(Integer value1, Integer value2) {
            addCriterion("mem_card_type between", value1, value2, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("mem_card_type not between", value1, value2, "memCardType");
            return (Criteria) this;
        }

        public Criteria andMemCardNoIsNull() {
            addCriterion("mem_card_no is null");
            return (Criteria) this;
        }

        public Criteria andMemCardNoIsNotNull() {
            addCriterion("mem_card_no is not null");
            return (Criteria) this;
        }

        public Criteria andMemCardNoEqualTo(String value) {
            addCriterion("mem_card_no =", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoNotEqualTo(String value) {
            addCriterion("mem_card_no <>", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoGreaterThan(String value) {
            addCriterion("mem_card_no >", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoGreaterThanOrEqualTo(String value) {
            addCriterion("mem_card_no >=", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoLessThan(String value) {
            addCriterion("mem_card_no <", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoLessThanOrEqualTo(String value) {
            addCriterion("mem_card_no <=", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoLike(String value) {
            addCriterion("mem_card_no like", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoNotLike(String value) {
            addCriterion("mem_card_no not like", value, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoIn(List<String> values) {
            addCriterion("mem_card_no in", values, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoNotIn(List<String> values) {
            addCriterion("mem_card_no not in", values, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoBetween(String value1, String value2) {
            addCriterion("mem_card_no between", value1, value2, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andMemCardNoNotBetween(String value1, String value2) {
            addCriterion("mem_card_no not between", value1, value2, "memCardNo");
            return (Criteria) this;
        }

        public Criteria andFreightPriceIsNull() {
            addCriterion("freight_price is null");
            return (Criteria) this;
        }

        public Criteria andFreightPriceIsNotNull() {
            addCriterion("freight_price is not null");
            return (Criteria) this;
        }

        public Criteria andFreightPriceEqualTo(BigDecimal value) {
            addCriterion("freight_price =", value, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceNotEqualTo(BigDecimal value) {
            addCriterion("freight_price <>", value, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceGreaterThan(BigDecimal value) {
            addCriterion("freight_price >", value, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("freight_price >=", value, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceLessThan(BigDecimal value) {
            addCriterion("freight_price <", value, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("freight_price <=", value, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceIn(List<BigDecimal> values) {
            addCriterion("freight_price in", values, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceNotIn(List<BigDecimal> values) {
            addCriterion("freight_price not in", values, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("freight_price between", value1, value2, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andFreightPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("freight_price not between", value1, value2, "freightPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceIsNull() {
            addCriterion("goods_total_price is null");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceIsNotNull() {
            addCriterion("goods_total_price is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceEqualTo(BigDecimal value) {
            addCriterion("goods_total_price =", value, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceNotEqualTo(BigDecimal value) {
            addCriterion("goods_total_price <>", value, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceGreaterThan(BigDecimal value) {
            addCriterion("goods_total_price >", value, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_total_price >=", value, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceLessThan(BigDecimal value) {
            addCriterion("goods_total_price <", value, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_total_price <=", value, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceIn(List<BigDecimal> values) {
            addCriterion("goods_total_price in", values, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceNotIn(List<BigDecimal> values) {
            addCriterion("goods_total_price not in", values, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_total_price between", value1, value2, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_total_price not between", value1, value2, "goodsTotalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNull() {
            addCriterion("total_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNotNull() {
            addCriterion("total_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceEqualTo(BigDecimal value) {
            addCriterion("total_price =", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_price <>", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThan(BigDecimal value) {
            addCriterion("total_price >", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price >=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThan(BigDecimal value) {
            addCriterion("total_price <", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price <=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIn(List<BigDecimal> values) {
            addCriterion("total_price in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_price not in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price not between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceIsNull() {
            addCriterion("payable_price is null");
            return (Criteria) this;
        }

        public Criteria andPayablePriceIsNotNull() {
            addCriterion("payable_price is not null");
            return (Criteria) this;
        }

        public Criteria andPayablePriceEqualTo(BigDecimal value) {
            addCriterion("payable_price =", value, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceNotEqualTo(BigDecimal value) {
            addCriterion("payable_price <>", value, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceGreaterThan(BigDecimal value) {
            addCriterion("payable_price >", value, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("payable_price >=", value, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceLessThan(BigDecimal value) {
            addCriterion("payable_price <", value, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("payable_price <=", value, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceIn(List<BigDecimal> values) {
            addCriterion("payable_price in", values, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceNotIn(List<BigDecimal> values) {
            addCriterion("payable_price not in", values, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("payable_price between", value1, value2, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayablePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("payable_price not between", value1, value2, "payablePrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceIsNull() {
            addCriterion("pay_price is null");
            return (Criteria) this;
        }

        public Criteria andPayPriceIsNotNull() {
            addCriterion("pay_price is not null");
            return (Criteria) this;
        }

        public Criteria andPayPriceEqualTo(BigDecimal value) {
            addCriterion("pay_price =", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceNotEqualTo(BigDecimal value) {
            addCriterion("pay_price <>", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceGreaterThan(BigDecimal value) {
            addCriterion("pay_price >", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_price >=", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceLessThan(BigDecimal value) {
            addCriterion("pay_price <", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_price <=", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceIn(List<BigDecimal> values) {
            addCriterion("pay_price in", values, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceNotIn(List<BigDecimal> values) {
            addCriterion("pay_price not in", values, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_price between", value1, value2, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_price not between", value1, value2, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNull() {
            addCriterion("pay_real_price is null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNotNull() {
            addCriterion("pay_real_price is not null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceEqualTo(BigDecimal value) {
            addCriterion("pay_real_price =", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <>", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThan(BigDecimal value) {
            addCriterion("pay_real_price >", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price >=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThan(BigDecimal value) {
            addCriterion("pay_real_price <", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIn(List<BigDecimal> values) {
            addCriterion("pay_real_price in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotIn(List<BigDecimal> values) {
            addCriterion("pay_real_price not in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price not between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andOrderStatusIsNull() {
            addCriterion("order_status is null");
            return (Criteria) this;
        }

        public Criteria andOrderStatusIsNotNull() {
            addCriterion("order_status is not null");
            return (Criteria) this;
        }

        public Criteria andOrderStatusEqualTo(Integer value) {
            addCriterion("order_status =", value, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusNotEqualTo(Integer value) {
            addCriterion("order_status <>", value, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusGreaterThan(Integer value) {
            addCriterion("order_status >", value, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("order_status >=", value, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusLessThan(Integer value) {
            addCriterion("order_status <", value, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusLessThanOrEqualTo(Integer value) {
            addCriterion("order_status <=", value, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusIn(List<Integer> values) {
            addCriterion("order_status in", values, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusNotIn(List<Integer> values) {
            addCriterion("order_status not in", values, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusBetween(Integer value1, Integer value2) {
            addCriterion("order_status between", value1, value2, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andOrderStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("order_status not between", value1, value2, "orderStatus");
            return (Criteria) this;
        }

        public Criteria andRemarksIsNull() {
            addCriterion("remarks is null");
            return (Criteria) this;
        }

        public Criteria andRemarksIsNotNull() {
            addCriterion("remarks is not null");
            return (Criteria) this;
        }

        public Criteria andRemarksEqualTo(String value) {
            addCriterion("remarks =", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotEqualTo(String value) {
            addCriterion("remarks <>", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksGreaterThan(String value) {
            addCriterion("remarks >", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksGreaterThanOrEqualTo(String value) {
            addCriterion("remarks >=", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksLessThan(String value) {
            addCriterion("remarks <", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksLessThanOrEqualTo(String value) {
            addCriterion("remarks <=", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksLike(String value) {
            addCriterion("remarks like", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotLike(String value) {
            addCriterion("remarks not like", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksIn(List<String> values) {
            addCriterion("remarks in", values, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotIn(List<String> values) {
            addCriterion("remarks not in", values, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksBetween(String value1, String value2) {
            addCriterion("remarks between", value1, value2, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotBetween(String value1, String value2) {
            addCriterion("remarks not between", value1, value2, "remarks");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNull() {
            addCriterion("total_deduction_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNotNull() {
            addCriterion("total_deduction_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price =", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <>", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThan(BigDecimal value) {
            addCriterion("total_deduction_price >", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price >=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThan(BigDecimal value) {
            addCriterion("total_deduction_price <", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price not in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price not between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceIsNull() {
            addCriterion("deduction_coupon_price is null");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceIsNotNull() {
            addCriterion("deduction_coupon_price is not null");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceEqualTo(BigDecimal value) {
            addCriterion("deduction_coupon_price =", value, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceNotEqualTo(BigDecimal value) {
            addCriterion("deduction_coupon_price <>", value, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceGreaterThan(BigDecimal value) {
            addCriterion("deduction_coupon_price >", value, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("deduction_coupon_price >=", value, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceLessThan(BigDecimal value) {
            addCriterion("deduction_coupon_price <", value, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("deduction_coupon_price <=", value, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceIn(List<BigDecimal> values) {
            addCriterion("deduction_coupon_price in", values, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceNotIn(List<BigDecimal> values) {
            addCriterion("deduction_coupon_price not in", values, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("deduction_coupon_price between", value1, value2, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionCouponPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("deduction_coupon_price not between", value1, value2, "deductionCouponPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceIsNull() {
            addCriterion("deduction_product_price is null");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceIsNotNull() {
            addCriterion("deduction_product_price is not null");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceEqualTo(BigDecimal value) {
            addCriterion("deduction_product_price =", value, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceNotEqualTo(BigDecimal value) {
            addCriterion("deduction_product_price <>", value, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceGreaterThan(BigDecimal value) {
            addCriterion("deduction_product_price >", value, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("deduction_product_price >=", value, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceLessThan(BigDecimal value) {
            addCriterion("deduction_product_price <", value, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("deduction_product_price <=", value, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceIn(List<BigDecimal> values) {
            addCriterion("deduction_product_price in", values, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceNotIn(List<BigDecimal> values) {
            addCriterion("deduction_product_price not in", values, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("deduction_product_price between", value1, value2, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andDeductionProductPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("deduction_product_price not between", value1, value2, "deductionProductPrice");
            return (Criteria) this;
        }

        public Criteria andPayGoldIsNull() {
            addCriterion("pay_gold is null");
            return (Criteria) this;
        }

        public Criteria andPayGoldIsNotNull() {
            addCriterion("pay_gold is not null");
            return (Criteria) this;
        }

        public Criteria andPayGoldEqualTo(Integer value) {
            addCriterion("pay_gold =", value, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldNotEqualTo(Integer value) {
            addCriterion("pay_gold <>", value, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldGreaterThan(Integer value) {
            addCriterion("pay_gold >", value, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldGreaterThanOrEqualTo(Integer value) {
            addCriterion("pay_gold >=", value, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldLessThan(Integer value) {
            addCriterion("pay_gold <", value, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldLessThanOrEqualTo(Integer value) {
            addCriterion("pay_gold <=", value, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldIn(List<Integer> values) {
            addCriterion("pay_gold in", values, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldNotIn(List<Integer> values) {
            addCriterion("pay_gold not in", values, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldBetween(Integer value1, Integer value2) {
            addCriterion("pay_gold between", value1, value2, "payGold");
            return (Criteria) this;
        }

        public Criteria andPayGoldNotBetween(Integer value1, Integer value2) {
            addCriterion("pay_gold not between", value1, value2, "payGold");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceIsNull() {
            addCriterion("surplus_refund_price is null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceIsNotNull() {
            addCriterion("surplus_refund_price is not null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price =", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceNotEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price <>", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceGreaterThan(BigDecimal value) {
            addCriterion("surplus_refund_price >", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price >=", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceLessThan(BigDecimal value) {
            addCriterion("surplus_refund_price <", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price <=", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceIn(List<BigDecimal> values) {
            addCriterion("surplus_refund_price in", values, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceNotIn(List<BigDecimal> values) {
            addCriterion("surplus_refund_price not in", values, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("surplus_refund_price between", value1, value2, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("surplus_refund_price not between", value1, value2, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralIsNull() {
            addCriterion("surplus_refund_integral is null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralIsNotNull() {
            addCriterion("surplus_refund_integral is not null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralEqualTo(Integer value) {
            addCriterion("surplus_refund_integral =", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralNotEqualTo(Integer value) {
            addCriterion("surplus_refund_integral <>", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralGreaterThan(Integer value) {
            addCriterion("surplus_refund_integral >", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralGreaterThanOrEqualTo(Integer value) {
            addCriterion("surplus_refund_integral >=", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralLessThan(Integer value) {
            addCriterion("surplus_refund_integral <", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralLessThanOrEqualTo(Integer value) {
            addCriterion("surplus_refund_integral <=", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralIn(List<Integer> values) {
            addCriterion("surplus_refund_integral in", values, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralNotIn(List<Integer> values) {
            addCriterion("surplus_refund_integral not in", values, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralBetween(Integer value1, Integer value2) {
            addCriterion("surplus_refund_integral between", value1, value2, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralNotBetween(Integer value1, Integer value2) {
            addCriterion("surplus_refund_integral not between", value1, value2, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNull() {
            addCriterion("pay_time is null");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNotNull() {
            addCriterion("pay_time is not null");
            return (Criteria) this;
        }

        public Criteria andPayTimeEqualTo(Date value) {
            addCriterion("pay_time =", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotEqualTo(Date value) {
            addCriterion("pay_time <>", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThan(Date value) {
            addCriterion("pay_time >", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("pay_time >=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThan(Date value) {
            addCriterion("pay_time <", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThanOrEqualTo(Date value) {
            addCriterion("pay_time <=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeIn(List<Date> values) {
            addCriterion("pay_time in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotIn(List<Date> values) {
            addCriterion("pay_time not in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeBetween(Date value1, Date value2) {
            addCriterion("pay_time between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotBetween(Date value1, Date value2) {
            addCriterion("pay_time not between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNull() {
            addCriterion("finish_time is null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNotNull() {
            addCriterion("finish_time is not null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeEqualTo(Date value) {
            addCriterion("finish_time =", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotEqualTo(Date value) {
            addCriterion("finish_time <>", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThan(Date value) {
            addCriterion("finish_time >", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("finish_time >=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThan(Date value) {
            addCriterion("finish_time <", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThanOrEqualTo(Date value) {
            addCriterion("finish_time <=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIn(List<Date> values) {
            addCriterion("finish_time in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotIn(List<Date> values) {
            addCriterion("finish_time not in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeBetween(Date value1, Date value2) {
            addCriterion("finish_time between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotBetween(Date value1, Date value2) {
            addCriterion("finish_time not between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNull() {
            addCriterion("cancel_time is null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNotNull() {
            addCriterion("cancel_time is not null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeEqualTo(Date value) {
            addCriterion("cancel_time =", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotEqualTo(Date value) {
            addCriterion("cancel_time <>", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThan(Date value) {
            addCriterion("cancel_time >", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("cancel_time >=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThan(Date value) {
            addCriterion("cancel_time <", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThanOrEqualTo(Date value) {
            addCriterion("cancel_time <=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIn(List<Date> values) {
            addCriterion("cancel_time in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotIn(List<Date> values) {
            addCriterion("cancel_time not in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeBetween(Date value1, Date value2) {
            addCriterion("cancel_time between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotBetween(Date value1, Date value2) {
            addCriterion("cancel_time not between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksIsNull() {
            addCriterion("cancel_remarks is null");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksIsNotNull() {
            addCriterion("cancel_remarks is not null");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksEqualTo(String value) {
            addCriterion("cancel_remarks =", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksNotEqualTo(String value) {
            addCriterion("cancel_remarks <>", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksGreaterThan(String value) {
            addCriterion("cancel_remarks >", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksGreaterThanOrEqualTo(String value) {
            addCriterion("cancel_remarks >=", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksLessThan(String value) {
            addCriterion("cancel_remarks <", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksLessThanOrEqualTo(String value) {
            addCriterion("cancel_remarks <=", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksLike(String value) {
            addCriterion("cancel_remarks like", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksNotLike(String value) {
            addCriterion("cancel_remarks not like", value, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksIn(List<String> values) {
            addCriterion("cancel_remarks in", values, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksNotIn(List<String> values) {
            addCriterion("cancel_remarks not in", values, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksBetween(String value1, String value2) {
            addCriterion("cancel_remarks between", value1, value2, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andCancelRemarksNotBetween(String value1, String value2) {
            addCriterion("cancel_remarks not between", value1, value2, "cancelRemarks");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIsNull() {
            addCriterion("refund_time is null");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIsNotNull() {
            addCriterion("refund_time is not null");
            return (Criteria) this;
        }

        public Criteria andRefundTimeEqualTo(Date value) {
            addCriterion("refund_time =", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotEqualTo(Date value) {
            addCriterion("refund_time <>", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeGreaterThan(Date value) {
            addCriterion("refund_time >", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("refund_time >=", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeLessThan(Date value) {
            addCriterion("refund_time <", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeLessThanOrEqualTo(Date value) {
            addCriterion("refund_time <=", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIn(List<Date> values) {
            addCriterion("refund_time in", values, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotIn(List<Date> values) {
            addCriterion("refund_time not in", values, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeBetween(Date value1, Date value2) {
            addCriterion("refund_time between", value1, value2, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotBetween(Date value1, Date value2) {
            addCriterion("refund_time not between", value1, value2, "refundTime");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumIsNull() {
            addCriterion("account_merchant_num is null");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumIsNotNull() {
            addCriterion("account_merchant_num is not null");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumEqualTo(String value) {
            addCriterion("account_merchant_num =", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumNotEqualTo(String value) {
            addCriterion("account_merchant_num <>", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumGreaterThan(String value) {
            addCriterion("account_merchant_num >", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumGreaterThanOrEqualTo(String value) {
            addCriterion("account_merchant_num >=", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumLessThan(String value) {
            addCriterion("account_merchant_num <", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumLessThanOrEqualTo(String value) {
            addCriterion("account_merchant_num <=", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumLike(String value) {
            addCriterion("account_merchant_num like", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumNotLike(String value) {
            addCriterion("account_merchant_num not like", value, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumIn(List<String> values) {
            addCriterion("account_merchant_num in", values, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumNotIn(List<String> values) {
            addCriterion("account_merchant_num not in", values, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumBetween(String value1, String value2) {
            addCriterion("account_merchant_num between", value1, value2, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNumNotBetween(String value1, String value2) {
            addCriterion("account_merchant_num not between", value1, value2, "accountMerchantNum");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusIsNull() {
            addCriterion("profit_sharing_status is null");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusIsNotNull() {
            addCriterion("profit_sharing_status is not null");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusEqualTo(Boolean value) {
            addCriterion("profit_sharing_status =", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusNotEqualTo(Boolean value) {
            addCriterion("profit_sharing_status <>", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusGreaterThan(Boolean value) {
            addCriterion("profit_sharing_status >", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusGreaterThanOrEqualTo(Boolean value) {
            addCriterion("profit_sharing_status >=", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusLessThan(Boolean value) {
            addCriterion("profit_sharing_status <", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusLessThanOrEqualTo(Boolean value) {
            addCriterion("profit_sharing_status <=", value, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusIn(List<Boolean> values) {
            addCriterion("profit_sharing_status in", values, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusNotIn(List<Boolean> values) {
            addCriterion("profit_sharing_status not in", values, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusBetween(Boolean value1, Boolean value2) {
            addCriterion("profit_sharing_status between", value1, value2, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingStatusNotBetween(Boolean value1, Boolean value2) {
            addCriterion("profit_sharing_status not between", value1, value2, "profitSharingStatus");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdIsNull() {
            addCriterion("profit_sharing_record_id is null");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdIsNotNull() {
            addCriterion("profit_sharing_record_id is not null");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdEqualTo(Long value) {
            addCriterion("profit_sharing_record_id =", value, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdNotEqualTo(Long value) {
            addCriterion("profit_sharing_record_id <>", value, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdGreaterThan(Long value) {
            addCriterion("profit_sharing_record_id >", value, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdGreaterThanOrEqualTo(Long value) {
            addCriterion("profit_sharing_record_id >=", value, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdLessThan(Long value) {
            addCriterion("profit_sharing_record_id <", value, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdLessThanOrEqualTo(Long value) {
            addCriterion("profit_sharing_record_id <=", value, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdIn(List<Long> values) {
            addCriterion("profit_sharing_record_id in", values, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdNotIn(List<Long> values) {
            addCriterion("profit_sharing_record_id not in", values, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdBetween(Long value1, Long value2) {
            addCriterion("profit_sharing_record_id between", value1, value2, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andProfitSharingRecordIdNotBetween(Long value1, Long value2) {
            addCriterion("profit_sharing_record_id not between", value1, value2, "profitSharingRecordId");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckIsNull() {
            addCriterion("whether_check is null");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckIsNotNull() {
            addCriterion("whether_check is not null");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckEqualTo(Boolean value) {
            addCriterion("whether_check =", value, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckNotEqualTo(Boolean value) {
            addCriterion("whether_check <>", value, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckGreaterThan(Boolean value) {
            addCriterion("whether_check >", value, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckGreaterThanOrEqualTo(Boolean value) {
            addCriterion("whether_check >=", value, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckLessThan(Boolean value) {
            addCriterion("whether_check <", value, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckLessThanOrEqualTo(Boolean value) {
            addCriterion("whether_check <=", value, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckIn(List<Boolean> values) {
            addCriterion("whether_check in", values, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckNotIn(List<Boolean> values) {
            addCriterion("whether_check not in", values, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckBetween(Boolean value1, Boolean value2) {
            addCriterion("whether_check between", value1, value2, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherCheckNotBetween(Boolean value1, Boolean value2) {
            addCriterion("whether_check not between", value1, value2, "whetherCheck");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateIsNull() {
            addCriterion("whether_rebate is null");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateIsNotNull() {
            addCriterion("whether_rebate is not null");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateEqualTo(Boolean value) {
            addCriterion("whether_rebate =", value, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateNotEqualTo(Boolean value) {
            addCriterion("whether_rebate <>", value, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateGreaterThan(Boolean value) {
            addCriterion("whether_rebate >", value, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateGreaterThanOrEqualTo(Boolean value) {
            addCriterion("whether_rebate >=", value, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateLessThan(Boolean value) {
            addCriterion("whether_rebate <", value, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateLessThanOrEqualTo(Boolean value) {
            addCriterion("whether_rebate <=", value, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateIn(List<Boolean> values) {
            addCriterion("whether_rebate in", values, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateNotIn(List<Boolean> values) {
            addCriterion("whether_rebate not in", values, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateBetween(Boolean value1, Boolean value2) {
            addCriterion("whether_rebate between", value1, value2, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andWhetherRebateNotBetween(Boolean value1, Boolean value2) {
            addCriterion("whether_rebate not between", value1, value2, "whetherRebate");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusIsNull() {
            addCriterion("exception_status is null");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusIsNotNull() {
            addCriterion("exception_status is not null");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusEqualTo(Boolean value) {
            addCriterion("exception_status =", value, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusNotEqualTo(Boolean value) {
            addCriterion("exception_status <>", value, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusGreaterThan(Boolean value) {
            addCriterion("exception_status >", value, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusGreaterThanOrEqualTo(Boolean value) {
            addCriterion("exception_status >=", value, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusLessThan(Boolean value) {
            addCriterion("exception_status <", value, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusLessThanOrEqualTo(Boolean value) {
            addCriterion("exception_status <=", value, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusIn(List<Boolean> values) {
            addCriterion("exception_status in", values, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusNotIn(List<Boolean> values) {
            addCriterion("exception_status not in", values, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusBetween(Boolean value1, Boolean value2) {
            addCriterion("exception_status between", value1, value2, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionStatusNotBetween(Boolean value1, Boolean value2) {
            addCriterion("exception_status not between", value1, value2, "exceptionStatus");
            return (Criteria) this;
        }

        public Criteria andExceptionContentIsNull() {
            addCriterion("exception_content is null");
            return (Criteria) this;
        }

        public Criteria andExceptionContentIsNotNull() {
            addCriterion("exception_content is not null");
            return (Criteria) this;
        }

        public Criteria andExceptionContentEqualTo(String value) {
            addCriterion("exception_content =", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentNotEqualTo(String value) {
            addCriterion("exception_content <>", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentGreaterThan(String value) {
            addCriterion("exception_content >", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentGreaterThanOrEqualTo(String value) {
            addCriterion("exception_content >=", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentLessThan(String value) {
            addCriterion("exception_content <", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentLessThanOrEqualTo(String value) {
            addCriterion("exception_content <=", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentLike(String value) {
            addCriterion("exception_content like", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentNotLike(String value) {
            addCriterion("exception_content not like", value, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentIn(List<String> values) {
            addCriterion("exception_content in", values, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentNotIn(List<String> values) {
            addCriterion("exception_content not in", values, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentBetween(String value1, String value2) {
            addCriterion("exception_content between", value1, value2, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andExceptionContentNotBetween(String value1, String value2) {
            addCriterion("exception_content not between", value1, value2, "exceptionContent");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeIsNull() {
            addCriterion("promote_code is null");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeIsNotNull() {
            addCriterion("promote_code is not null");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeEqualTo(String value) {
            addCriterion("promote_code =", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeNotEqualTo(String value) {
            addCriterion("promote_code <>", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeGreaterThan(String value) {
            addCriterion("promote_code >", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeGreaterThanOrEqualTo(String value) {
            addCriterion("promote_code >=", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeLessThan(String value) {
            addCriterion("promote_code <", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeLessThanOrEqualTo(String value) {
            addCriterion("promote_code <=", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeLike(String value) {
            addCriterion("promote_code like", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeNotLike(String value) {
            addCriterion("promote_code not like", value, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeIn(List<String> values) {
            addCriterion("promote_code in", values, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeNotIn(List<String> values) {
            addCriterion("promote_code not in", values, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeBetween(String value1, String value2) {
            addCriterion("promote_code between", value1, value2, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andPromoteCodeNotBetween(String value1, String value2) {
            addCriterion("promote_code not between", value1, value2, "promoteCode");
            return (Criteria) this;
        }

        public Criteria andSecUserIdIsNull() {
            addCriterion("sec_user_id is null");
            return (Criteria) this;
        }

        public Criteria andSecUserIdIsNotNull() {
            addCriterion("sec_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andSecUserIdEqualTo(Long value) {
            addCriterion("sec_user_id =", value, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdNotEqualTo(Long value) {
            addCriterion("sec_user_id <>", value, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdGreaterThan(Long value) {
            addCriterion("sec_user_id >", value, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sec_user_id >=", value, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdLessThan(Long value) {
            addCriterion("sec_user_id <", value, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdLessThanOrEqualTo(Long value) {
            addCriterion("sec_user_id <=", value, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdIn(List<Long> values) {
            addCriterion("sec_user_id in", values, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdNotIn(List<Long> values) {
            addCriterion("sec_user_id not in", values, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdBetween(Long value1, Long value2) {
            addCriterion("sec_user_id between", value1, value2, "secUserId");
            return (Criteria) this;
        }

        public Criteria andSecUserIdNotBetween(Long value1, Long value2) {
            addCriterion("sec_user_id not between", value1, value2, "secUserId");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt4IsNull() {
            addCriterion("ext_4 is null");
            return (Criteria) this;
        }

        public Criteria andExt4IsNotNull() {
            addCriterion("ext_4 is not null");
            return (Criteria) this;
        }

        public Criteria andExt4EqualTo(String value) {
            addCriterion("ext_4 =", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotEqualTo(String value) {
            addCriterion("ext_4 <>", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4GreaterThan(String value) {
            addCriterion("ext_4 >", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4GreaterThanOrEqualTo(String value) {
            addCriterion("ext_4 >=", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4LessThan(String value) {
            addCriterion("ext_4 <", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4LessThanOrEqualTo(String value) {
            addCriterion("ext_4 <=", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4Like(String value) {
            addCriterion("ext_4 like", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotLike(String value) {
            addCriterion("ext_4 not like", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4In(List<String> values) {
            addCriterion("ext_4 in", values, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotIn(List<String> values) {
            addCriterion("ext_4 not in", values, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4Between(String value1, String value2) {
            addCriterion("ext_4 between", value1, value2, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotBetween(String value1, String value2) {
            addCriterion("ext_4 not between", value1, value2, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt5IsNull() {
            addCriterion("ext_5 is null");
            return (Criteria) this;
        }

        public Criteria andExt5IsNotNull() {
            addCriterion("ext_5 is not null");
            return (Criteria) this;
        }

        public Criteria andExt5EqualTo(String value) {
            addCriterion("ext_5 =", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotEqualTo(String value) {
            addCriterion("ext_5 <>", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5GreaterThan(String value) {
            addCriterion("ext_5 >", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5GreaterThanOrEqualTo(String value) {
            addCriterion("ext_5 >=", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5LessThan(String value) {
            addCriterion("ext_5 <", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5LessThanOrEqualTo(String value) {
            addCriterion("ext_5 <=", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5Like(String value) {
            addCriterion("ext_5 like", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotLike(String value) {
            addCriterion("ext_5 not like", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5In(List<String> values) {
            addCriterion("ext_5 in", values, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotIn(List<String> values) {
            addCriterion("ext_5 not in", values, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5Between(String value1, String value2) {
            addCriterion("ext_5 between", value1, value2, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotBetween(String value1, String value2) {
            addCriterion("ext_5 not between", value1, value2, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt6IsNull() {
            addCriterion("ext_6 is null");
            return (Criteria) this;
        }

        public Criteria andExt6IsNotNull() {
            addCriterion("ext_6 is not null");
            return (Criteria) this;
        }

        public Criteria andExt6EqualTo(String value) {
            addCriterion("ext_6 =", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6NotEqualTo(String value) {
            addCriterion("ext_6 <>", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6GreaterThan(String value) {
            addCriterion("ext_6 >", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6GreaterThanOrEqualTo(String value) {
            addCriterion("ext_6 >=", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6LessThan(String value) {
            addCriterion("ext_6 <", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6LessThanOrEqualTo(String value) {
            addCriterion("ext_6 <=", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6Like(String value) {
            addCriterion("ext_6 like", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6NotLike(String value) {
            addCriterion("ext_6 not like", value, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6In(List<String> values) {
            addCriterion("ext_6 in", values, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6NotIn(List<String> values) {
            addCriterion("ext_6 not in", values, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6Between(String value1, String value2) {
            addCriterion("ext_6 between", value1, value2, "ext6");
            return (Criteria) this;
        }

        public Criteria andExt6NotBetween(String value1, String value2) {
            addCriterion("ext_6 not between", value1, value2, "ext6");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}