package com.hai.service;

import com.hai.entity.HighDiscountAgentBatch;

import java.util.List;
import java.util.Map;

/**
 * @className: HighDiscountAgentBatchService
 * @author: HuRui
 * @date: 2023/8/16
 **/
public interface HighDiscountAgentBatchService {

    /**
     * 编辑数据
     * @param discountAgentBatch
     */
    void editData(HighDiscountAgentBatch discountAgentBatch);

    /**
     * 根据标识查询数据
     * @param identifier
     * @return
     */
    HighDiscountAgentBatch getBatchByIdentifier(String identifier);

    /**
     * 获取使用统计
     * @param param
     * @return
     */List<Map<String,Object>> getUsageCount(Map<String, Object> param);

    /**
     * 获取统计
     * @param param
     * @return
     */
     Map<String,Object> getCount(Map<String, Object> param);
}
